import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

class Player {

    // IA un peu à la Monte Carlo : Je teste toutes les possibilités et je joue celle qui me donne le plus de victoires
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        Random random = new Random();
        int dimension =in.nextInt();
        int rounds= in.nextInt();
        int path_length= in.nextInt();
        int dimension2=dimension*dimension;
        int[] grille=new int[dimension2]; // Grille en une seule array de longueur dimension²
        int[] grille_temp;
        int etape=0; // Pour savoir combien de cases sont déjà posées par moi
        int[] victoires=new int[dimension2]; // Me permet de garder en mémoire le nombre de victoires de chaque case
        int numero_joueur;
        int[] cases_jouees;
        int cases;
        int[] scores=new int[2];
        int[] scores_temp;

        int[] fourmi;
        // Traduction direction -> modificateur dans la grille pour la fourmi
        // direction 0 vers la droite puis sens trigo
        int[] directions = {1, -dimension, -1, dimension};
        int ma_couleur=-1;

        // Boucle du jeu
        while (true) {
            //int compteur=0; // A supprimer
            int opponentRow = in.nextInt();
            int opponentCol = in.nextInt();
            Arrays.fill(victoires,-1000000);
            if (opponentRow==-1){
                ma_couleur=0;
            } else {
                if (ma_couleur == -1) {
                    ma_couleur = 1;
                }
                grille[opponentRow * dimension + opponentCol] = 2;
                scores[1]++;
            }
            long t0=System.currentTimeMillis();

            while (System.currentTimeMillis()<t0+275){
                // On complete la  grille au hasard puis on regarde le score
                //compteur++;
                cases_jouees=new int[2*rounds-(2*etape+ma_couleur)];
                numero_joueur=0;
                grille_temp=grille.clone();
                scores_temp=scores.clone();
                // On joue au hasard les "rounds" cases à choisir des deux joueurs
                for (int turn=0;turn<2*rounds-(2*etape+ma_couleur);turn++){
                    // On cherche une case à jouer
                    while (true) {
                        cases=random.nextInt(dimension2-1);
                        if(grille_temp[cases]==0){
                            break;
                        }
                    }
                    // On fait comme si on avait joué cette case
                    grille_temp[cases]=numero_joueur+1;
                    numero_joueur=1-numero_joueur;
                    cases_jouees[turn]=cases;
                    scores_temp[numero_joueur]++;
                }
                // On fait avancer la fourmi
                fourmi=new int[]{(dimension2+dimension)/2,1,ma_couleur};

                for (int turn = 0; turn < path_length; turn++) {
                /*
                if (turn<25) {
                    System.err.printf("Etape n° %d%n", turn);
                    afficherGrille(grille_temp, n / 2 - 3, n / 2 + 3);
                }
                */
                    // On change la couleur de la case où elle est
                    if (grille_temp[fourmi[0]] == 0) {// Si la case est vide
                        fourmi[1] = (fourmi[1] + 3) % 4;// On fait tourner la fourmi
                        grille_temp[fourmi[0]] = fourmi[2]+1; // On colorie la case
                        scores_temp[fourmi[2]]++;// On modifie le score

                    } else { // Sinon on enleve la couleur
                        fourmi[1] = (fourmi[1] + 1) % 4;// On fait tourner la fourmi
                        fourmi[2]=grille_temp[fourmi[0]]-1;
                        scores_temp[fourmi[2]]--; // On modifie le score
                        grille_temp[fourmi[0]] = 0; // maj grille

                    }
                    // On fait avancer la fourmi
                    fourmi[0] += directions[fourmi[1]];
                    // Si on sort de l'écran, on s'arrete
                    if (fourmi[0]>= dimension2 || fourmi[0] < 0 || (fourmi[1]==0 && (fourmi[0]%dimension)==0) || (fourmi[1]==2 && ((fourmi[0]+1)%dimension)==0)) {
                        break;
                    }
                }
                // Si on a un meilleur score que l'adversaire, on rajoute une victoire pour chaque case que j'ai choisi
                //if (scores_temp[0]>scores_temp[1]){
                for(int turn=0;turn<2*rounds-(2*etape+ma_couleur);turn+=2){
                    if (victoires[cases_jouees[turn]]==-1000000){victoires[cases_jouees[turn]]=0;}
                    victoires[cases_jouees[turn]]+=scores_temp[0]-scores_temp[1];

                }
                //}
            }

            // On cherche la case avec le plus grand nombre de victoire
            int val_max=-1000000;
            int case_max=0;
            for (int i=0; i<dimension2;i++){
                if (victoires[i]>val_max ){
                    val_max=victoires[i];
                    case_max=i;
                    //System.err.printf("%d %d%n",case_max,val_max);
                }
            }
            etape++;
            scores[0]++;
            grille[case_max]=1;
            //System.err.println(compteur);
            System.out.println(String.format("%d %d",case_max/dimension, case_max%dimension));
            //afficherGrille(grille,10,20,dimension);
        }
    }

    // Pour debug
    private static void afficherGrille(int[] grille,int min,int max,int dimension){
        for(int i=min;i<=max;i++){
            for(int j=min;j<=max;j++){
                System.err.printf("%d ",grille[i*dimension+j]);
            }
            System.err.println();
        }
    }


}